#include <stdio.h>
#include <stdlib.h>

struct cell {
  int clef;
  struct cell *suiv;
};

int longueur(struct cell *pc) {
  if (pc == NULL)
    return 0;
  else
    return longueur(pc->suiv) + 1;
}

void afficher(struct cell *pc) {
  if (pc == NULL) {
    puts("Liste Vide");
    return;
  }
  printf("%d\t", pc->clef);
  if (pc->suiv != NULL)
    afficher(pc->suiv);
  else
    printf("\n");
}

struct cell *empiler(struct cell *pc, int n) {
  struct cell *prem = malloc(sizeof(struct cell));
  prem->clef = n;
  prem->suiv = pc;
  return prem;
}

struct cell *ajouter(struct cell *pc, int n) {
  if (pc == NULL) {
    struct cell *der = malloc(sizeof(struct cell));
    der->clef = n;
    der->suiv = NULL;
    return der;
  }
  pc->suiv = ajouter(pc->suiv, n);
  return pc;
}


struct cell *depiler(struct cell *pc) {
  if (pc == NULL)
    return pc;

  struct cell *new = pc->suiv;
  free(pc);
  return new;
}

struct cell *supprimer(struct cell *pc) {
  if (pc == NULL)
    return pc;

  if (pc->suiv == NULL) {
    free(pc);
    pc = NULL;
  } else {
    pc->suiv = supprimer(pc->suiv);
  }
  return pc;
}

// Exercice 2

void detruire(struct cell *pc) {
  while (pc != NULL)
    pc = depiler(pc);
}

void detruire2(struct cell *pc) {
  if (pc == NULL)
    return;

  struct cell * suiv = pc->suiv;
  free(pc);
  detruire2(suiv);
}


struct cell *copier(struct cell *pc) {
  if (pc == NULL)
    return NULL;
  return empiler(copier(pc->suiv),pc->clef);
}


struct cell *chainer(struct cell *pc1, struct cell *pc2) {
  if (pc1 == NULL)
    return pc2;

  pc1->suiv = chainer(pc1->suiv, pc2);
  return pc1;
}

int main() {
  struct cell *pc = NULL;
  struct cell *copie = NULL;
  afficher(pc);                /* affiche "Liste vide" */
  pc = empiler(pc,1);
  pc = empiler(pc,0);
  printf("%d\n",longueur(pc)); /* affiche "2"          */
  afficher(pc);               /* affiche "0 1"        */
  pc = ajouter(pc,2);
  afficher(pc);               /* affiche "0 1 2"      */
  pc = depiler(pc);
  afficher(pc);               /* affiche "1 2"        */
  pc = supprimer(pc);
  afficher(pc);               /* affiche "1"          */

  pc = ajouter(pc,4);
  copie = copier(pc);
  afficher(pc);               /* affiche "1 4"          */
  afficher(copie);               /* affiche "1 4"          */
  pc = empiler(pc,6);
  chainer(pc, copie);
  afficher(pc);
  return 0;
}
