#include <stdio.h>
#include <stdlib.h>

typedef struct lcc 
{
  int valeur;
  struct lcc *suivant;
} lcc;

int occurrences(int n, lcc l)
{
  lcc *debut, *actuel;
  int occurrences;
  
  actuel = debut = &l;
  
  do {
    if (actuel->valeur == n) occurrences++;
    actuel = actuel->suivant;
  } while (actuel != debut);

  return occurrences;  
}

lcc *dernier_element(lcc *l)
{
  lcc *fin = l;
  while (fin->suivant != l)
    fin = fin->suivant;
  return fin;
}

void concat_en_place(lcc *l1, lcc *l2) 
{
  lcc *fin;

  fin = dernier_element(l1);
  fin->suivant = l2;
  fin = dernier_element(l2);
  fin->suivant = l1;
}

lcc *concat_copie(lcc *l1, lcc *l2)
{
  lcc *nouvelle, *ancienne, *nouvelle_debut, *actuel = l1;
  
  nouvelle_debut = nouvelle = malloc(sizeof(lcc));
  nouvelle->valeur = actuel->valeur;
  actuel = actuel->suivant;

  while (actuel != l1) {
    ancienne = nouvelle;
    nouvelle = malloc(sizeof(lcc));
    ancienne->suivant = nouvelle;
    nouvelle->valeur = actuel->valeur;
    actuel = actuel->suivant;
  }

  actuel = l2;
  do {
    ancienne = nouvelle;
    nouvelle = malloc(sizeof(lcc));
    ancienne->suivant = nouvelle;
    nouvelle->valeur = actuel->valeur;
    actuel = actuel->suivant;
  } while(actuel != l2);

  nouvelle->suivant = nouvelle_debut;

  return nouvelle_debut;
}

lcc *supprime_occurrences(int n, lcc *l)
{
  lcc *p, *actuel = l;

  while (actuel->suivant != l) {
    if(actuel->suivant->valeur == n) {
      p = actuel->suivant;
      actuel->suivant = actuel->suivant->suivant;
      free(p);
    }
    actuel = actuel->suivant;
  }

  if (l->valeur == n) {
    actuel->suivant = l->suivant;
    free(l);
  }  

  return actuel->suivant;
}

lcc *construit_lcc (int *tab, int taille)
{
  lcc *debut, *l;
  int i;

  debut = l = malloc(sizeof(lcc));
  l->valeur = tab[0];

  for(i=1; i<taille; i++, l=l->suivant) {
    l->suivant = malloc(sizeof(lcc));
    l->suivant->valeur = tab[i];
  }

  l->suivant = debut;

  return debut;
}

void affiche_lcc (char *s, lcc *l)
{
  lcc *actuel = l;
  printf("%s",s);
  do {
    printf("%d ", actuel->valeur);
    actuel = actuel->suivant;
  } while (actuel != l);
  
  printf("\n");
}


int main(void)
{
  lcc *l1,*l2,*l3;
  int tab1[3] = {1,2,3};
  int tab2[4] = {4,5,6,7};
      
  l1 = construit_lcc(tab1,3);
  l2 = construit_lcc(tab2,4);
  affiche_lcc("l1 = ",l1);
  affiche_lcc("l2 = ",l2);
  concat_en_place(l1,l2);
  affiche_lcc("l1 = ",l1);
  l1 = supprime_occurrences(4,l1);
  affiche_lcc("l1 = ",l1);
  l1 = construit_lcc(tab1,3);
  l2 = construit_lcc(tab2,4);
  l3 = concat_copie(l1,l2);
  affiche_lcc("l3 = ",l3);
  affiche_lcc("l1 = ",l1);
  affiche_lcc("l2 = ",l2);
  return 0;
}
